/**
 ******************************************************************************
 * @file           : main.c
 * @author         : Auto-generated by STM32CubeIDE
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */

#include <stdint.h>

#if !defined(__SOFT_FP__) && defined(__ARM_FP)
  #warning "FPU is not initialized, but the project is compiling for an FPU. Please initialize the FPU before use."
#endif

// below symbols which hold addresses
// are defined in the linker script
extern uint32_t _estack;
extern uint32_t _msp_stack;
extern uint32_t _psp_stack;

int add(int a, int b, int c, int d, int e) {
  return a+b+c+d+e;
}

void SVC_Handler() {
  // this function call uses MSP
  int sum = add(6,7,8,9,10);
}

__attribute__((naked)) void changeStackToPSP(void) {
  // change PSP
  __asm volatile("LDR R0, =_psp_stack");
  __asm volatile("MSR PSP, R0");

  // set SPSEL bit
  __asm volatile("MRS R1, CONTROL");
  __asm volatile("ORR R1, R1, #2");
  __asm volatile("MSR CONTROL, R1");

  // return
  __asm volatile("BX LR");
}

void callSVC() {
  __asm volatile("SVC #0");
}

int main(void)
{
  // get addresses of defined symbols in linker scripts
  // note the use of the '&' operators
  uint32_t* end_stack = &_estack;
  uint32_t* msp_stack = &_msp_stack;
  uint32_t* psp_stack = &_psp_stack;

  changeStackToPSP();
  // this function call uses PSP
  int sum = add(1,2,3,4,5);

  // trigger SVC will force to use MSP
  callSVC();

  /* Loop forever */
	for(;;);
}
